// forceRandomCPU.h
// By Joseph K Aicher, Summer 2014 with Professor Russell M Taylor II

#include "genericForce.h"
#include <random>

#ifndef FORCERANDOMCPU_H
#define FORCERANDOMCPU_H

class forceRandomCPU : public genericForce
{
protected :
    // what is our random force parameter going to be?
    CS_REAL theRandomForce;

    // random engine
    std::mt19937 rEngine; // instantiation of the mersenne-twister engine
    std::normal_distribution< CS_REAL > rNormal;

public :
    // constructor
    forceRandomCPU (
        std::string sim_CLdir, // the path of directory with our openCL source code
        cl_context sim_context, // OpenCL context passed in from simulation
        cl_command_queue sim_queue, // OpenCL queue passed in from simulation,
        cl_ulong sim_numParticles, // number of particles in the simulation
        cl_ulong sim_totalMaxInteractions, // total maximum number of interactions (per particle) in Jacobian
        CS_REAL sim_timeStep, // the time step in the simulation
        CS_REAL randomForce, // the random force parameter from the configuration file
        int randomSeed // seed being used by the random number generator
        );

    // updates clForce with random forces
    virtual void calculateForce ( );
    
    // gets the name of the force
    virtual const char * getName ( );
};

#endif
