#!/bin/bash 

# Remember that it will put out an output file with the name output.blend
# in the same directory as its original output file, so put each one of
# the files from multiple simultaneous runs in their own directories.

# Parse the command line.
if [ $# != 2 ] ; then echo Usage: $0 Blender_file Input_file ; exit ; fi
BLENDER_FILE=$1
INPUT_FILE=$2
SCRIPT_FILE=${BLENDER_FILE}.py

# Copy the template Blender file to be the file we want to end up with.
cp vidprecode4_batch.blend ${BLENDER_FILE}

# Edit the template Python script to point to the correct input file.
cat read_chromoShake_file_into_blender.py | sed 's#INPUT_FILE.txt#'"${INPUT_FILE}"'#g' > $SCRIPT_FILE

# Qsub a script to run and produce the requested output file using the specified input files.
c:/Program\ Files\ \(x86\)/Blender\ Foundation/Blender/blender.exe -b "${BLENDER_FILE}" -P "${SCRIPT_FILE}" -noaudio

